/*
 * Fri Feb 28 07:47:13 1997  Doug Lea  (dl at gee)
 * Based on PolyLineHandle
 */
package CH.ifa.draw.contrib;

import CH.ifa.draw.framework.DrawingView;
import CH.ifa.draw.framework.Locator;

import CH.ifa.draw.standard.AbstractHandle;

import java.awt.Point;


/**
 * A handle for a node on the polygon.
 */
public class PolygonHandle extends AbstractHandle {
    private int fIndex;
    private Locator fLocator;

    /**
     * Constructs a polygon handle.
     * @param owner the owning polygon figure.
     * @param l     the locator
     * @param index the index of the node associated with this handle.
     */
    public PolygonHandle(PolygonFigure owner, Locator l, int index) {
        super(owner);
        fLocator = l;
        fIndex = index;
    }

    public void invokeStep(int x, int y, int anchorX, int anchorY,
                           DrawingView view) {
        myOwner().setPointAt(new Point(x, y), fIndex);
    }

    public void invokeEnd(int x, int y, int anchorX, int anchorY,
                          DrawingView view) {
        myOwner().smoothPoints();
        super.invokeEnd(x, y, anchorX, anchorY, view);
    }

    public Point locate() {
        return fLocator.locate(owner());
    }

    private PolygonFigure myOwner() {
        return (PolygonFigure) owner();
    }
}