package de.renew.call;

import de.renew.engine.searcher.EarlyExecutable;
import de.renew.engine.searcher.Tracer;

import de.renew.unify.Impossible;


class BlockExecutable implements EarlyExecutable {
    SynchronisationRequest synchronisation;

    BlockExecutable(SynchronisationRequest synchronisation) {
        this.synchronisation = synchronisation;
    }

    public int phase() {
        return BLOCK;
    }

    public long lockPriority() {
        return synchronisation.lockOrder;
    }

    public void lock() {
        synchronisation.lock.lock();
    }

    public void verify() throws Impossible {
        if (synchronisation.completed) {
            throw new Impossible();
        }
    }

    public void execute(Tracer tracer) {
        synchronisation.completed = true;
    }

    public void rollback() {
        // Nothing to do.
    }

    public void unlock() {
        synchronisation.lock.unlock();
    }
}