/**
 * ConsoleTracerFactory.java
 *
 *
 * Created: Thu Mar  9 10:59:13 2000
 *
 * @author Frank Wienberg
 * @version 1.1
 */
package de.renew.engine.searcher;

public class ConsoleTracerFactory implements TracerFactory {
    private final String pureConstantPrefix;
    private final String constantPrefix;
    private final String constantSuffix;

    public ConsoleTracerFactory() {
        pureConstantPrefix = null;
        constantPrefix = "";
        constantSuffix = "";
    }

    public ConsoleTracerFactory(String constantPrefix) {
        this.pureConstantPrefix = constantPrefix;
        this.constantPrefix = "(" + constantPrefix;
        this.constantSuffix = ") ";
    }

    public Tracer getTracer(String initialMessage, String prefix) {
        return new ConsoleTracer(initialMessage,
                                 constantPrefix + prefix + constantSuffix);
    }

    public TracerFactory newChildFactory(String additionalPrefix) {
        if (additionalPrefix == null && pureConstantPrefix == null) {
            return new ConsoleTracerFactory();
        } else {
            return new ConsoleTracerFactory(((additionalPrefix == null) ? ""
                                                                        : additionalPrefix)
                                            + ((additionalPrefix == null) ? ""
                                                                          : constantPrefix));
        }
    }
}