package de.renew.net;

import de.renew.engine.searcher.LateExecutable;
import de.renew.engine.searcher.Tracer;

import de.renew.net.event.FiringEvent;


public class FiringCompleteExecutable implements LateExecutable {
    private FiringEvent event;

    FiringCompleteExecutable(FiringEvent event) {
        this.event = event;
    }

    public int phase() {
        return END;
    }

    public boolean isLong() {
        return false;
    }

    public void execute(Tracer tracer) {
        event.getTransitionInstance().firingComplete(event);
    }

    public void executeAfterException(Tracer tracer, Throwable t) {
        // Proceed as normal.
        execute(tracer);
    }
}