package de.renew.net;

import de.renew.engine.searcher.Searcher;

import de.renew.expression.VariableMapper;

import de.renew.unify.Impossible;

import java.util.Collections;


public class ManualInscription implements TransitionInscription {
    private static ManualInscription singleton;

    private ManualInscription() {
    }

    public static synchronized ManualInscription getInstance() {
        if (singleton == null) {
            singleton = new ManualInscription();
        }

        return singleton;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher)
            throws Impossible {
        return Collections.EMPTY_SET;
    }
}