package de.renew.net.arc;

import de.renew.engine.searcher.EarlyExecutable;
import de.renew.engine.searcher.Tracer;

import de.renew.net.PlaceInstance;

import de.renew.unify.Impossible;


class InhibitorExecutable implements EarlyExecutable {
    PlaceInstance placeInstance;
    Object token;
    boolean trace;

    InhibitorExecutable(PlaceInstance placeInstance, Object token, boolean trace) {
        this.placeInstance = placeInstance;
        this.token = token;
        this.trace = trace;
    }

    public long lockPriority() {
        return placeInstance.lockOrder;
    }

    public int phase() {
        // Test before other executables have the chance to remove
        // tokens from the place.
        return INHIBIT;
    }

    public void lock() {
        placeInstance.lock.lock();
    }

    public void verify() throws Impossible {
        if (placeInstance.containsTestableToken(token)) {
            // Undo locking.
            throw new Impossible();
        }
    }

    public void execute(Tracer tracer) {
        // Does it really make sense to output a trace message?
        if (trace) {
            tracer.trace("    Inhibiting " + token + " at " + placeInstance);
        }
    }

    public void rollback() {
        // No harm done.
    }

    public void unlock() {
        placeInstance.lock.unlock();
    }
}