package de.renew.net.inscription;

import de.renew.engine.searcher.Searcher;

import de.renew.expression.LocalVariable;
import de.renew.expression.VariableMapper;

import de.renew.net.Net;
import de.renew.net.NetInstance;
import de.renew.net.TransitionInscription;

import java.util.Collections;


public class CreationInscription implements TransitionInscription {
    private Net net;
    private LocalVariable createVariable;

    public CreationInscription(Net net, LocalVariable createVariable) {
        this.net = net;
        this.createVariable = createVariable;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher) {
        return Collections.singleton(new CreationOccurrence(mapper.map(createVariable),
                                                            net));
    }
}