package de.renew.net.inscription;

import de.renew.engine.common.SimpleEnumeratorOccurrence;
import de.renew.engine.searcher.Searcher;

import de.renew.expression.Expression;
import de.renew.expression.VariableMapper;

import de.renew.net.NetInstance;
import de.renew.net.TransitionInscription;

import de.renew.unify.Impossible;

import java.util.Collection;
import java.util.Collections;


public class SimpleEnumeratorInscription implements TransitionInscription {
    private Expression expr;
    private boolean checkBound;
    private Collection collection;

    public SimpleEnumeratorInscription(Expression expr, Collection collection,
                                       boolean checkBound) {
        this.expr = expr;
        this.collection = collection;
        this.checkBound = checkBound;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher)
            throws Impossible {
        return Collections.singleton(new SimpleEnumeratorOccurrence(expr,
                                                                    checkBound,
                                                                    mapper,
                                                                    collection));
    }
}