package de.renew.shadow;

import de.renew.net.Place;
import de.renew.net.Transition;

import java.util.Enumeration;
import java.util.Hashtable;


public class ContextLookup {
    private Hashtable map;

    public ContextLookup(ShadowLookup shadowLookup) {
        map = new Hashtable();

        Enumeration places = shadowLookup.allPlaces();
        while (places.hasMoreElements()) {
            ShadowPlace shadowPlace = (ShadowPlace) places.nextElement();
            Place place = shadowLookup.get(shadowPlace);
            map.put(shadowPlace.context, place);
        }

        Enumeration transitions = shadowLookup.allTransitions();
        while (transitions.hasMoreElements()) {
            ShadowTransition shadowTransition = (ShadowTransition) transitions
                                                .nextElement();
            Transition transition = shadowLookup.get(shadowTransition);
            map.put(shadowTransition.context, transition);
        }
    }

    public Place getPlace(Object context) {
        return (Place) map.get(context);
    }

    public Transition getTransition(Object context) {
        return (Transition) map.get(context);
    }

    public Hashtable getMap() {
        return map;
    }
}