package de.renew.shadow;

import de.renew.net.NetNotFoundException;


/**
 *
 * <p>
 * </p>
 * ShadowNetLoader.java
 * Created: Wed Dec  5  2001
 * @author Michael Duvigneau
 **/
public interface ShadowNetLoader {

    /**
     * Tries to load a shadow net from an external source (for
     * example a file) and inserts it into the given<code>
     * ShadowNetSystem</code>. This method is called by the compiler
     * if and only if there is no known net for the given name.
     *
     * @param netName    the name of the missing net.
     *
     * @param netSystem  the net system to put the loaded net into.
     *
     * @return
     *   the new <code>ShadowNet</code> object, if the loader was
     *   able to find and load the net from an external source.
     *   May not return <code>null</code> - the loader has to throw
     *   a <code>NetNotFoundException</code> instead.
     *
     * @throws NetNotFoundException
     *   if the loader could not find a source for a net with the
     *   given name.
     **/
    public ShadowNet loadShadowNet(String netName, ShadowNetSystem netSystem)
            throws NetNotFoundException;
}